ECのコールバック実行順序を修正する
2012/01/11 01:51 - n-ando
カテゴリ:  予定工数: 0.00時間

対象バージョン:    

説明

現在のECはon_executeとon_state_updateの実行順序がA,BというRTCが同一ECにアタッチされている場合、

A:on_execute->A:on_state_update->B:on_execute->B:on_state_update

 

となっているが、OMG RTC標準仕様にしたがって、

A:on_execute->B:on_execute->A:on_state_update->B:on_state_update

 

となるように修正する。

修正項目としては、

1. StateMachine::worker() を worker_pre(), worker_do(), worker_post()に分割し、それぞれでpre_do, do,
post_doコールバックを呼ぶように変更する。

2. PeriodicEC内でfor_eachでworker()を呼んでいる部分をworker_pre(), worker_do(), worker_post()に分割する。

関係しているリビジョン
リビジョン 527 - 2012/03/13 16:43 - kurihara

[incompatible] ExecutionContextBase's super classes have been moved to PeriodicExecutionContext class.  refs #2323

[incomaptible API] Now ExecutionContextProfile management has been moved to ExecutionContextBase. getObjRef() is also moved to
ExecutionContextBase.
[incompatible behavior] Now onExecute and onStateUpdate execution behavior has been changed when two or more RTCs attached to the EC. refs
#2320
Old: A::onExecute, A::onStateUpdate, B::onExecute, B::onStateUpdate
New: A::onExecute, B::onExecute, A::onStateUpdate, B::onStateUpdate

リビジョン 529 - 2012/03/13 17:04 - kurihara

[incomaptible impl] worker() has been now divided into three functions: worker_pre(), worker_do(), worker_post(). refs #2320

履歴
#1 - 2012/02/08 23:41 - kurihara

- 担当者 を kurihara にセット

#2 - 2012/02/10 18:01 - kurihara

- ステータス を 新規 から 担当 に変更
#3 - 2012/03/13 16:43 - kurihara

- ステータス を 担当 から 解決 に変更

- 進捗率 を 0 から 100 に変更

r527 , r529  にて対応済み。

#4 - 2012/03/30 17:41 - n-ando

- ステータス を 解決 から 終了 に変更
https://www.openrtm.org/redmine/projects/openrtm-aist-python/repository/revisions/527
https://www.openrtm.org/redmine/projects/openrtm-aist-python/repository/revisions/529
